/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_MOTIVOPARC                                                     */
/* Tabela : MOTIVOPARC                                                              */
/*                                                                                  */
/* Criao:                                                                         */
/* 29/05/2009 -                                                                */
/*                                                                                  */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_MOTIVOPARC
BEFORE INSERT OR UPDATE OR DELETE
ON MOTIVOPARC FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUMPAR := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDMOTIPARC,0) <> NVL(:NEW.CDMOTIPARC,0)) OR
         (NVL(:OLD.DSMOTIPARC,0) <> NVL(:NEW.DSMOTIPARC,0)) THEN
         :NEW.DTULTATUMPAR := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('MOTIVOPARC', '', 'CDMOTIPARC='||:OLD.CDMOTIPARC||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE MOTIVOPARC MODIFY DTULTATUPAIS DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_MOTIVOPARC','5.07.015'); END;
/

