
-- 9003_CTBSTP_ATUALIZA_SALDO_CONTABIL.SQL --

CREATE OR REPLACE PROCEDURE ATUALIZA_SALDO_CONTABIL(
	P_CDEMPRESA IN EMPRESA.CDEMPRESA%TYPE)
IS
BEGIN
DECLARE
   V_DTFINACONT DATE;
   DATA_SALDO DATE;
   V_DATAINIC DATE;
   V_CONTSALDO CHAR;
   V_IDSALDEMPR  CHAR;
   V_SEMSALDO CHAR;
   V_NRSEQ VARCHAR2(10);

   CURSOR C_LANCCTBL (P_DATAINIC DATE, P_DTFINACONT DATE) IS
      SELECT LANCCONT.CDEMPRESA,LANCCONT.CDCONTCTBL,IDLANCSALDO,VRLANCAMENT,
             SALDEMPR.CDEMPRESA, SALDEMPR.CDCONTCTBL,DTSALDEMPR,VRSALDEMPR
      FROM LANCCONT, SALDEMPR, CONTCTBL
      WHERE (LANCCONT.CDEMPRESA   = P_CDEMPRESA)         AND
            (LANCCONT.IDLANCSALDO = 'N')                 AND
            (SALDEMPR.CDEMPRESA   = P_CDEMPRESA)         AND
            (LANCCONT.CDCONTCTBL  = SALDEMPR.CDCONTCTBL) AND
            (SALDEMPR.DTSALDEMPR BETWEEN P_DATAINIC AND P_DTFINACONT) AND
            (LANCCONT.CDCONTCTBL = CONTCTBL.CDCONTCTBL) AND
            (IDCONTCCUS <> 'R')
      FOR UPDATE;

   CURSOR C_LANCDEL (P_DATAINIC DATE, P_DTFINACONT DATE) IS
      SELECT NRSEQLANEX
      FROM LANCONTEX, CONTCTBL
      WHERE (CDEMPRESA = P_CDEMPRESA) AND
            (DTLANCCONEX BETWEEN P_DATAINIC AND P_DTFINACONT) AND
            (LANCONTEX.CDCONTALAEX = CONTCTBL.CDCONTCTBL) AND
            (CONTCTBL.IDCONTCCUS <> 'R')
      FOR UPDATE;

   BEGIN

      SELECT MAX(DTFINACONT) INTO V_DTFINACONT
      FROM CONTOPECTBL
      WHERE CDEMPRESA = P_CDEMPRESA;

      IF V_DTFINACONT IS NULL THEN
         raise_application_error(-20502, 'Perodo contbil no cadastrado.', True);
      END IF;

      SELECT MIN(DTLANCCONT) INTO V_DATAINIC
      FROM LANCCONT, CONTCTBL
      WHERE (LANCCONT.CDEMPRESA   = P_CDEMPRESA) AND
            (LANCCONT.IDLANCSALDO = 'N') AND
            (LANCCONT.CDCONTCTBL = CONTCTBL.CDCONTCTBL) AND
            (CONTCTBL.IDCONTCCUS <> 'R');

      IF V_DATAINIC IS NULL THEN
         SELECT MIN(DTLANCCONCOM) INTO V_DATAINIC
         FROM LANCOMEEX, CONTCTBL
         WHERE (CDEMPRESA = P_CDEMPRESA) AND
               (LANCOMEEX.CDCONTALACOM = CONTCTBL.CDCONTCTBL) AND
               (CONTCTBL.IDCONTCCUS <> 'R');
      END IF;

      OPEN C_LANCCTBL(V_DATAINIC, V_DTFINACONT);
      CLOSE C_LANCCTBL;

      OPEN C_LANCDEL(V_DATAINIC, V_DTFINACONT);

      DATA_SALDO := LAST_DAY(V_DATAINIC );

      WHILE (DATA_SALDO <= V_DTFINACONT) LOOP

	  FOR SOMACONTA IN
             (SELECT LANCCONT.CDCONTCTBL, SUM(LANCCONT.VRLANCAMENT) AS VALORSALDO
              FROM LANCCONT, CONTCTBL
	      WHERE (LANCCONT.CDEMPRESA  = P_CDEMPRESA) AND
                   (LANCCONT.IDLANCSALDO = 'N')         AND
                   (LANCCONT.DTLANCCONT BETWEEN V_DATAINIC AND DATA_SALDO) AND
                   (LANCCONT.CDCONTCTBL = CONTCTBL.CDCONTCTBL) AND
                   (CONTCTBL.IDCONTCCUS <> 'R')
              GROUP BY LANCCONT.CDCONTCTBL
              UNION ALL
              SELECT LANCONTEX.CDCONTALAEX AS CDCONTCTBL, SUM(VRLANCCONEX) AS VALORSALDO
              FROM LANCONTEX, CONTCTBL
              WHERE (CDEMPRESA = P_CDEMPRESA) AND
                    (DTLANCCONEX BETWEEN V_DATAINIC AND DATA_SALDO) AND
                    (LANCONTEX.CDCONTALAEX = CONTCTBL.CDCONTCTBL) AND
                    (CONTCTBL.IDCONTCCUS <> 'R')
              GROUP BY CDCONTALAEX ) LOOP

             SELECT COUNT(*) INTO V_SEMSALDO
             FROM SALDEMPR
             WHERE (CDEMPRESA  = P_CDEMPRESA)          AND
                   (CDCONTCTBL = SOMACONTA.CDCONTCTBL) AND
                   (DTSALDEMPR = DATA_SALDO);

             IF V_SEMSALDO = 0 THEN
                INSERT INTO SALDEMPR
	          (CDEMPRESA, CDCONTCTBL, DTSALDEMPR, VRSALDEMPR)
	          (SELECT P_CDEMPRESA, CDCONTCTBL, DATA_SALDO, 0 FROM CONTCTBL
                 WHERE  (CdContCtbl NOT IN (SELECT DISTINCT CdContCtbl
                                            FROM SALDEMPR
                                            WHERE ((CDEMPRESA  = P_CDEMPRESA)   AND
                                                  (DTSALDEMPR  = DATA_SALDO)))) AND
                        (INSTR(SOMACONTA.CDCONTCTBL,RTRIM(CONTCTBL.CDCONTCTBL)) = 1));

		  END IF;

	          UPDATE SALDEMPR SET VRSALDEMPR = SALDEMPR.VRSALDEMPR + SOMACONTA.VALORSALDO
		    WHERE (SALDEMPR.DTSALDEMPR = DATA_SALDO) AND
                      (SALDEMPR.CDEMPRESA  = P_CDEMPRESA) AND
		          (INSTR(SOMACONTA.CDCONTCTBL,RTRIM(SALDEMPR.CDCONTCTBL)) = 1);

          END LOOP;

          DATA_SALDO := ADD_MONTHS(DATA_SALDO,1);

       END LOOP;

       LOOP
       FETCH C_LANCDEL INTO V_NRSEQ;
          EXIT WHEN C_LANCDEL%NOTFOUND;
          DELETE FROM LANCONTEX
          WHERE (NRSEQLANEX = V_NRSEQ);
       END LOOP;
       CLOSE C_LANCDEL;

       UPDATE LANCCONT SET IDLANCSALDO = 'S'
       WHERE (CDEMPRESA   = P_CDEMPRESA) AND
             (IDLANCSALDO = 'N') ;

   END;
END;
/

/

-- VERSAO --
BEGIN ATUVEROBJ('ATUALIZA_SALDO_CONTABIL','4.09.090'); END;
/

