 /* Tabela INCIDENCIA: Incidncia */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela INCIDENCIA */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Incidncia,
             utilizando a tabela Geral de Logs de Operaes */

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_FIS_INCIDENCIA' AND
                 TYPE   = 'TR' 		           AND
	              U.UID  = O.UID                AND
	              U.NAME = USER)
DROP TRIGGER LOG_FIS_INCIDENCIA
GO


CREATE TRIGGER LOG_FIS_INCIDENCIA
ON INCIDENCIA
FOR INSERT, UPDATE, DELETE
AS


   DECLARE  @V_USUARIO   VARCHAR(40);
   DECLARE  @V_TIPO      VARCHAR(1);
   DECLARE  @V_ITPESQ    VARCHAR(40);
   DECLARE  @V_DESC      VARCHAR(300);
   DECLARE  @V_DTOPER    DATETIME;
   DECLARE  @V_CDARVPROD_OLD    VARCHAR(20);
   DECLARE  @V_CDARVPROD_NEW    VARCHAR(20);

/*VARIVEIS DO CURSOR C_CURSOR*/

   DECLARE  @V_ID_COMANDO        VARCHAR(1);

   DECLARE @V_NRINCIDENCIA_OLD   VARCHAR(10);
   DECLARE @V_CDPRODUTO_OLD      VARCHAR(10);
   DECLARE @V_CDEMPRESA_OLD      VARCHAR(2);
   DECLARE @V_CDINSCESTA_OLD     VARCHAR(16);
   DECLARE @V_IDENTRSAIDIN_OLD   VARCHAR(1);
   DECLARE @V_CDTIPOOPER_OLD     VARCHAR(2);
   DECLARE @V_CDIMPOSTO_OLD      VARCHAR(2);
   DECLARE @V_CDFISCAL_OLD       VARCHAR(1);
   DECLARE @V_CDGRUPOFISC_OLD    VARCHAR(3);
   DECLARE @V_IDINCINTEREST_OLD  VARCHAR(1);

   DECLARE @V_NRINCIDENCIA_NEW  VARCHAR(10);
   DECLARE @V_CDPRODUTO_NEW     VARCHAR(10);
   DECLARE @V_CDEMPRESA_NEW     VARCHAR(2);
   DECLARE @V_CDINSCESTA_NEW    VARCHAR(16);
   DECLARE @V_IDENTRSAIDIN_NEW  VARCHAR(1);
   DECLARE @V_CDTIPOOPER_NEW    VARCHAR(2);
   DECLARE @V_CDIMPOSTO_NEW     VARCHAR(2);
   DECLARE @V_CDFISCAL_NEW      VARCHAR(1);
   DECLARE @V_CDGRUPOFISC_NEW   VARCHAR(3);
   DECLARE @V_IDINCINTEREST_NEW VARCHAR(1);

BEGIN
   SET @V_TIPO = '0';
   SET @V_DESC = '';

   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO, '');

   DECLARE C_CURSOR CURSOR FOR
   SELECT
     'D' IDCOMANDO,
      NRINCIDENCIA,
      CDPRODUTO,
      CDEMPRESA,
      CDINSCESTA,
      IDENTRSAIDIN,
      CDTIPOOPER,
      CDIMPOSTO,
      CDFISCAL,
      CDGRUPOFISC,
      IDINCINTEREST,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL

   FROM
      DELETED
   WHERE
      NRINCIDENCIA NOT IN (SELECT NRINCIDENCIA FROM INSERTED)
   UNION ALL

   SELECT
     'U' IDCOMANDO,
      DELETED.NRINCIDENCIA,
      DELETED.CDPRODUTO,
      DELETED.CDEMPRESA,
      DELETED.CDINSCESTA,
      DELETED.IDENTRSAIDIN,
      DELETED.CDTIPOOPER,
      DELETED.CDIMPOSTO,
      DELETED.CDFISCAL,
      DELETED.CDGRUPOFISC,
      DELETED.IDINCINTEREST,
      INSERTED.NRINCIDENCIA,
      INSERTED.CDPRODUTO,
      INSERTED.CDEMPRESA,
      INSERTED.CDINSCESTA,
      INSERTED.IDENTRSAIDIN,
      INSERTED.CDTIPOOPER,
      INSERTED.CDIMPOSTO,
      INSERTED.CDFISCAL,
      INSERTED.CDGRUPOFISC,
      INSERTED.IDINCINTEREST

   FROM
      INSERTED,
      DELETED
   WHERE
      INSERTED.NRINCIDENCIA = DELETED.NRINCIDENCIA
   UNION ALL

   SELECT
     'I' IDCOMANDO,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NRINCIDENCIA,
      CDPRODUTO,
      CDEMPRESA,
      CDINSCESTA,
      IDENTRSAIDIN,
      CDTIPOOPER,
      CDIMPOSTO,
      CDFISCAL,
      CDGRUPOFISC,
      IDINCINTEREST

   FROM
      INSERTED
   WHERE
      NRINCIDENCIA NOT IN (SELECT NRINCIDENCIA FROM DELETED);

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_NRINCIDENCIA_OLD,
                                 @V_CDPRODUTO_OLD,
                                 @V_CDEMPRESA_OLD,
                                 @V_CDINSCESTA_OLD,
                                 @V_IDENTRSAIDIN_OLD,
                                 @V_CDTIPOOPER_OLD,
                                 @V_CDIMPOSTO_OLD,
                                 @V_CDFISCAL_OLD,
                                 @V_CDGRUPOFISC_OLD,
				 @V_IDINCINTEREST_OLD,

                                 @V_NRINCIDENCIA_NEW,
                                 @V_CDPRODUTO_NEW,
                                 @V_CDEMPRESA_NEW,
                                 @V_CDINSCESTA_NEW,
                                 @V_IDENTRSAIDIN_NEW,
                                 @V_CDTIPOOPER_NEW,
                                 @V_CDIMPOSTO_NEW,
                                 @V_CDFISCAL_NEW,
                                 @V_CDGRUPOFISC_NEW,
				 @V_IDINCINTEREST_NEW;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO = 'D' BEGIN
         IF @V_CDPRODUTO_OLD IS NOT NULL BEGIN
            SELECT @V_CDARVPROD_OLD = CDARVPROD
            FROM PRODUTO
 	    WHERE CDPRODUTO = @V_CDPRODUTO_OLD;
	    IF @V_CDARVPROD_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Prod=' + @V_CDARVPROD_OLD;
            END;
         END;

         IF @V_CDEMPRESA_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Empr=' + @V_CDEMPRESA_OLD;
         END;

         IF @V_CDINSCESTA_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' InscEsta=' + @V_CDINSCESTA_OLD;
         END;

         IF @V_IDENTRSAIDIN_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' EntrSaid=' + @V_IDENTRSAIDIN_OLD;
         END;

         IF @V_CDTIPOOPER_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' TipoOper=' + @V_CDTIPOOPER_OLD;
         END;

         IF @V_CDIMPOSTO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Impo=' + @V_CDIMPOSTO_OLD;
         END;

         IF @V_CDFISCAL_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CdFisc=' + @V_CDFISCAL_OLD;
         END;

         IF @V_CDGRUPOFISC_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' GrupOper=' + @V_CDGRUPOFISC_OLD;
         END;

	 IF @V_IDINCINTEREST_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' OperInterEst=' + @V_IDINCINTEREST_OLD;
         END;

         SET @V_TIPO = '3';
         SET @V_ITPESQ = @V_NRINCIDENCIA_OLD;
      END
      ELSE
         IF @V_ID_COMANDO= 'U' /*UPDATING*/ BEGIN
            IF (@V_CDEMPRESA_NEW     <> @V_CDEMPRESA_OLD)    OR
               (@V_CDINSCESTA_NEW    <> @V_CDINSCESTA_OLD)   OR
               (@V_IDENTRSAIDIN_NEW  <> @V_IDENTRSAIDIN_OLD) OR
               (@V_CDTIPOOPER_NEW    <> @V_CDTIPOOPER_OLD)   OR
               (@V_CDIMPOSTO_NEW     <> @V_CDIMPOSTO_OLD)    OR
               (@V_CDFISCAL_NEW      <> @V_CDFISCAL_OLD)     OR
	       (@V_IDINCINTEREST_NEW <> @V_IDINCINTEREST_OLD)OR
               (ISNULL(@V_CDGRUPOFISC_NEW, '!') <> ISNULL(@V_CDGRUPOFISC_OLD, '!'))  OR
               (ISNULL(@V_CDPRODUTO_NEW, '!')   <> ISNULL(@V_CDPRODUTO_OLD, '!'))    BEGIN

               SET @V_TIPO   = '2';
               SET @V_ITPESQ = @V_NRINCIDENCIA_OLD;
            END;
         END;
         ELSE  BEGIN
            SET @V_TIPO   = '1';
            SET @V_ITPESQ = @V_NRINCIDENCIA_NEW;
         END;
      
      SELECT @V_CDARVPROD_NEW = CDARVPROD 
      FROM PRODUTO
      WHERE CDPRODUTO = @V_CDPRODUTO_NEW;

      IF @V_CDARVPROD_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' Prod=' + @V_CDARVPROD_NEW;
      END;

      IF @V_CDEMPRESA_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' Empr=' + @V_CDEMPRESA_NEW;
      END;

      IF @V_CDINSCESTA_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' InscEsta=' + @V_CDINSCESTA_NEW;
      END;

      IF @V_IDENTRSAIDIN_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' EntrSaid=' + @V_IDENTRSAIDIN_NEW;
      END;

      IF @V_CDTIPOOPER_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' TipoOper=' + @V_CDTIPOOPER_NEW;
      END;

      IF @V_CDIMPOSTO_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' Impo=' + @V_CDIMPOSTO_NEW;
      END;

      IF @V_CDFISCAL_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' CdFisc=' + @V_CDFISCAL_NEW;
      END;

      IF @V_CDGRUPOFISC_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' GrupOper=' + @V_CDGRUPOFISC_NEW;
      END;

      IF @V_IDINCINTEREST_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' OperInterEst=' + @V_IDINCINTEREST_NEW;
      END;

      IF @V_TIPO <> '0' BEGIN
         EXEC NMUSUARIO @V_USUARIO;
         IF NOT @V_DESC IS NULL BEGIN
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER = GETDATE();

               INSERT INTO LOGOPERA
                  (NMTABELA,   DTOPERACAO, NMRESPOPER,
                   IDTIPOOPER, CDPESQITEM, DSOPERACAO)
               VALUES
                  ('INCIDENCIA',  @V_DTOPER, @V_USUARIO,
                   @V_TIPO,      @V_ITPESQ, @V_DESC);
            END;
         END;
      END;
      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_NRINCIDENCIA_OLD,
                                 @V_CDPRODUTO_OLD,
                                 @V_CDEMPRESA_OLD,
                                 @V_CDINSCESTA_OLD,
                                 @V_IDENTRSAIDIN_OLD,
                                 @V_CDTIPOOPER_OLD,
                                 @V_CDIMPOSTO_OLD,
                                 @V_CDFISCAL_OLD,
                                 @V_CDGRUPOFISC_OLD,
				 @V_IDINCINTEREST_OLD,

                                 @V_NRINCIDENCIA_NEW,
                                 @V_CDPRODUTO_NEW,
                                 @V_CDEMPRESA_NEW,
                                 @V_CDINSCESTA_NEW,
                                 @V_IDENTRSAIDIN_NEW,
                                 @V_CDTIPOOPER_NEW,
                                 @V_CDIMPOSTO_NEW,
                                 @V_CDFISCAL_NEW,
                                 @V_CDGRUPOFISC_NEW,
  				 @V_IDINCINTEREST_NEW;

   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'LOG_FIS_INCIDENCIA','5.25.000';
GO

