var ger01903_impostoproduto_controller = function(ScreenService, templateManager, General, ZhFilterPreferences) {
    
    var self = this;
    
    this.openFilter = function(args){
        var widget = args.owner;
        ZhFilterPreferences.startFiltering(widget);
    };
    
    this.setUnitImposto = function(widget){
        widget.currentRow.CDFILIAL = General.getFieldValue('CDFILIAL', 'impostos');
    };
    
    this.configAfterApply = function(widget){
        var widgetImposto = templateManager.container.getWidget('impostos');
        widgetImposto.currentRow.CDFILIAL = widget.currentRow.CDFILIAL;
         widgetImposto.dataSourceFilter[4].value = widget.currentRow.CDFILIAL;
        widgetImposto.reload().then(function(response){
            widgetImposto.currentRow = response.dataset.paraVendasImpostoProduto[0];
        });
    };
    
    this.loadDataImposto = function(args){ 
        var widget = args.owner;
        var widgetImpo = templateManager.container.getWidget('impostos');
        var fieldPIS    = widgetImpo.getField(VRALIQPIS_FIELD),
            fieldCOFINS = widgetImpo.getField(VRALIQCOFINS_FIELD);
        widgetImpo.dataSourceFilter[3].value =  widget.__filterPopup.currentRow.CDFILIAL;
        widgetImpo.reload().then(function(data){
            widgetImpo.currentRow = data.dataset.paraVendasImpostoProduto[0];
             templateManager.container.getWidget('prodConfig').reload();
            fieldPIS.readOnly    = 
            fieldCOFINS.readOnly = !(!!(widgetImpo.currentRow.CDCSTPISCOF) && !!(widgetImpo.currentRow.CDCFOPPFIS));
            
        });
        
    };
    
    this.configTelaOnChange = function(args){
        var field = args.owner.field;
        var fieldDSBUTTON = field.widget.getField('DSBUTTON');     
            fieldDSBUTTON.readOnly = (field.value() == null || field.value() == '');
            fieldDSBUTTON.dataSourceFilter[2].value = field.widget.currentRow.NRCONFTELA;
            fieldDSBUTTON.value(null);
    };
    
    const IMPOSTPROD_WIDGET         = 'paraVendaImpostoProduto',
          IMPOSTPRODPOPUP_WIDGET    = 'paraVendaImpostoProdutoPopup',
          NMPRODINICIAL_FIELD       = 'NMPRODINICIAL',
          NMPRODFINAL_FIELD         = 'NMPRODFINAL',
          CDCSTICMS_FIELD           = 'CDCSTICMS',
          CDCSTPISCOF_FIELD         = 'CDCSTPISCOF',
          VRALIQPIS_FIELD           = 'VRALIQPIS',
          VRALIQCOFINS_FIELD        = 'VRALIQCOFINS',
          CDCEST_FIELD              = 'CDCEST',
          NMPRODUTOFIN_FIELD        = 'NMPRODUTOFIN';
          
    
    this.editImposto = function (widget) {
		General.widgetEdit(widget);
		
		widget.currentRow.CDFILIAL = Array.isArray(widget.currentRow.CDFILIAL) ? widget.currentRow.CDFILIAL : [widget.currentRow.CDFILIAL];
		widget.currentRow.NMFILIAL = Array.isArray(widget.currentRow.NMFILIAL) ? widget.currentRow.NMFILIAL : [widget.currentRow.NMFILIAL];
		widget.getField('CDFILIAL').reload();
    };
    
    this.cancelNewTax = function(args){
        var widget = args.owner.widget;
        General.widgetCancelForm(widget);
        delete widget.getField('CDFILIAL').validations.required;
    };
    
    this.saveImposto = function (widget) {
        if (widget.isValid()) {
            widget.saveRow().then(function(response) {
			    widget.currentRow.changed = false;
				widget.reload();
				widget.view();
			}).catch(function(response) {
				ScreenService.errorNotification(response.data.error);
			});
        }
    };
    
    this.impostosAfterMoveRow = function(args){
        var widget = args.owner;
        widget.activate();

        setAliquotaVisibility(widget, false);
        
        widget.fields.forEach(function (field){ 
            if(field.dataSourceFilter !== undefined){
                field.dataSourceFilter.forEach(function (filter) {
                    if (filter.name == 'CDFILIAL'){
                        filter.value = widget.currentRow.CDFILIAL;
                    }
                });
            }
        });
    };
    
    this.setCDSITUTRIBorCDSITUTRIBNFE = function (args) {
        var widget = args.owner.field.widget;   
        
        widget.currentRow.CDSITUTRIB = widget.currentRow.CDCSTPISCOF;
        widget.currentRow.CDSITUTRIBNFE = widget.currentRow.CDCSTPISCOF;
    };
    
    this.setClearImposto = function (args) {
        var widget = args.owner.field.widget;  
        widget.currentRow.CDCSTICMS = '';
        widget.getField('CDCSTICMS').value('');
    };
    
    var setAliquotaVisibility = function (widget, setNull) {
        var fieldPIS    = widget.getField(VRALIQPIS_FIELD),
            fieldCOFINS = widget.getField(VRALIQCOFINS_FIELD);
        
        fieldPIS.readOnly    = 
        fieldCOFINS.readOnly = !(!!(widget.currentRow.CDCSTPISCOF) && !!(widget.currentRow.CDCFOPPFIS));
        
        if (setNull)
            widget.currentRow.VRALIQCOFINS  = 
            widget.currentRow.VRALIQPIS     = null;
        
        self.updateDataSourceFilter(widget, fieldPIS);
        self.updateDataSourceFilter(widget, fieldCOFINS);
        
        widget.activate();
    };
    
    this.updateDataSourceFilter = function (widget, widgetToUpdate) {
    	widgetToUpdate.dataSourceFilter.forEach(function(filter) {
			
			filter.value = Util.clone(widget.currentRow[filter.name]);
    		
    		if(filter.name === 'NRORG') {
    			filter.value = getLocalVar('NRORG');
    		}
    	});
    	return widgetToUpdate.reload();
    };
    
    this.isAliquotaVisible = function (widget) {
        
        setAliquotaVisibility(widget, true);
    };
    
    this.saveImpostoProduto = function (widget) {
        var row = widget.currentRow;
		row.CDNVPRODUTO = General.getLevelByMask('GER_CDPICTPROD', 1).length;
        if (widget.isValid()) {
            
            row.VRPEALIMPFIS    = General.valueToFloat(row.VRPEALIMPFIS);
            row.VRPERCREDUCAO   = General.valueToFloat(row.VRPERCREDUCAO);
            row.VRALIQIBPT      = General.valueToFloat(row.VRALIQIBPT);
            row.VRALIQIBPTES    = General.valueToFloat(row.VRALIQIBPTES);
            
            if(parseFloat(row.VRPEALIMPFIS < 0)){
                row.VRPEALIMPFIS = row.VRPEALIMPFIS * (-1);
            }
            
            if(parseFloat(row.VRPERCREDUCAO < 0)){
                row.VRPERCREDUCAO = row.VRPERCREDUCAO * (-1);
            }
            
            if(parseFloat(row.VRALIQIBPT < 0)){
                row.VRALIQIBPT = row.VRALIQIBPT * (-1);
            }
            
            if(parseFloat(row.VRALIQIBPTES < 0)){
                row.VRALIQIBPTES = row.VRALIQIBPTES * (-1);
            }
                 
            if(!row.CDCSTPISCOF){
                row.VRALIQPIS = 0;
                row.VRALIQCOFINS = 0;
            }
            General.widgetSave(widget).then(function(response){
                if(response.messages[0].type == 'W'){
                    ScreenService.showMessage(response.messages[0].message, 'alert');
                }else {
                    ScreenService.showMessage('Certifique-se de que a aba Produto->Fiscal foi parametrizada. Unidades já cadastradas, foram alteradas!', 'alert');
                }
                delete widget.getField('CDFILIAL').validations.required;
    		    widget.reload();
            }).catch(function(response) {
                ScreenService.errorNotification(response.data.error);
            });
        }
    };
    
	this.newProdTax = function(args) { 
		var widget = args.owner.widget;
		widget.getField('CDFILIAL').validations.required = true;
		General.widgetNewRow(widget);
		widget.currentRow.NRORG = getLocalVar('NRORG');
		widget.currentRow.CDPRODUTO = General.getFieldValue('CDPRODUTO', 'Detalhamento');
		widget.currentRow.CDARVPROD = General.getFieldValue('CDARVPROD', 'Detalhamento');
		widget.currentRow.NMPRODUTO = General.getFieldValue('NMPRODUTO', 'Detalhamento');
		widget.currentRow.CDPRPAITABPR = General.getFieldValue('CDPRODUTO', 'Detalhamento');
		widget.currentRow.CDBARPRODUTO = General.getFieldValue('CDBARPRODUTO', 'Detalhamento');
		if(widget.appliedFilter.FILTER_ROW.CDFILIAL !== ''){
			widget.currentRow.CDFILIAL = widget.appliedFilter.FILTER_ROW.CDFILIAL;
		}
		widget.reload();
	};
	
	this.exportImposto = function(widget) {
	    var exportPopup = templateManager.container.getWidget('exportImpos');
	    ScreenService.openPopup(exportPopup);
    	exportPopup.currentRow = widget.currentRow;
    	exportPopup.currentRow.CDFILIALORIG = exportPopup.currentRow.CDFILIAL;
    	delete exportPopup.currentRow.CDFILIAL;
	    templateManager.container.getWidget('impostos').activate();
	};
    
    this.saveExport = function (widget) {
        var row = widget.currentRow;
		row.CDNVPRODUTO = General.getLevelByMask('GER_CDPICTPROD', 1).length;
        if (widget.isValid()) {
            
            row.VRPEALIMPFIS    = General.valueToFloat(row.VRPEALIMPFIS);
            row.VRPERCREDUCAO   = General.valueToFloat(row.VRPERCREDUCAO);
            row.VRALIQIBPT      = General.valueToFloat(row.VRALIQIBPT);
            row.VRALIQIBPTES    = General.valueToFloat(row.VRALIQIBPTES);
                 
            row.VRPEALIMPFIS = parseFloat(row.VRPEALIMPFIS) < 0 ? row.VRPEALIMPFIS * (-1) : row.VRPEALIMPFIS;
            row.VRPERCREDUCAO = parseFloat(row.VRPERCREDUCAO) < 0 ? row.VRPERCREDUCAO * (-1) : row.VRPERCREDUCAO;
            row.VRALIQIBPT = parseFloat(row.VRALIQIBPT) < 0 ? row.VRALIQIBPT * (-1) : row.VRALIQIBPT;
            row.VRALIQIBPTES = parseFloat(row.VRALIQIBPTES) < 0 ? row.VRALIQIBPTES * (-1) : row.VRALIQIBPTES;
            
            if(!row.CDCSTPISCOF){
                row.VRALIQPIS = 0;
                row.VRALIQCOFINS = 0;
            }
            row.__is_new = true;
            General.callRestEngine('cadEst#/ger01900_cadastroproduto_venda_imposto_export', 'Row', row);
            delete widget.getField('CDFILIAL').validations.required;
            ScreenService.closePopup(widget);
		    ScreenService.closeSwipe();
        }
    };
};

Configuration(function (ContextRegister, eventEngine) {
	ContextRegister.register('ger01903_impostoproduto_controller', ger01903_impostoproduto_controller);
});